from rv import commands, rvtypes
from rv.commands import NeutralMenuState
import rv.qtutils
import rv.commands

class Example_Package_ExampleRVMenuMode(rvtypes.MinorMode):

    def __init__(self):
        rvtypes.MinorMode.__init__(self)

        globalBindings = [("preferences-show", self.runExample, "DescriptionOfBinding")]
        localBindings = None
        self.uiBuilt = False

        self.init("Example_Package_ExampleRVMenu", globalBindings, localBindings, [])

    def buildPrefs(self):
        if self.uiBuilt:
            return

        from PySide2 import QtGui, QtCore, QtWidgets

        ## Main Session Window
        sessionWindow = rv.qtutils.sessionWindow()

        rvPrefs = sessionWindow.findChild(QtWidgets.QDialog, "RvPreferences")
        # We want to amend a tab, so find the 'tabWidget' object.
        # As a simple example, I'm just adding a button, but you can do
        # your whole layout here.
        tabWidget = rvPrefs.findChild(QtWidgets.QTabWidget, "tabWidget")
        myPrefs = QtWidgets.QWidget(tabWidget)
        tabWidget.addTab(myPrefs, "My Preferences")
        myLayout = QtWidgets.QFormLayout()
        but = QtWidgets.QPushButton("Set up My Preferences")

        ## Add Items to your form Layout here
        myLayout.addRow("A custom button", but)

        myPrefs.setLayout(myLayout)

        self.uiBuilt = True

    def runExample(self, event):
        print "Gonna build my custom prefs!"
        self.buildPrefs()


def createMode():
    return Example_Package_ExampleRVMenuMode()
